/* SDAL-SCREENSHOT
- Der Spieler macht einen Screenshot und wird gebannt.
- Um wieder entbannt zu werden, soll er den Screenshot an die Adresse schicken,
  die mit der Cvar "sv_contact" definiert ist.
- Es wird eine screenshot.cfg angelegt, in der alle Spielernamen gespeichert sind,
  von denen ein Screenshot gemacht wurde.		
*/

#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

new STRING_VERSION[MAX_DATA_LENGTH] = "02.01.04";

/*Kontakt-Adresse*/
new g_Contact[MAX_TEXT_LENGTH];

/*Defines the g_ScreenshotCFG for the info: Date/Time, Playername and his wonid*/
new g_ScreenshotCFG[MAX_DATA_LENGTH]="addons/adminmod/config/screenshot.cfg";

public plugin_init() {
	getstrvar("sv_contact",g_Contact,MAX_TEXT_LENGTH);
	if(strlen(g_Contact)==0){
		plugin_registerinfo("SDAL-Screenshot Script","Die Cvar ^"sv_contact^" ist nicht gesetzt! Script nicht aktiv!",STRING_VERSION);
	}else{
		plugin_registerinfo("SDAL-Screenshot Script","Forces player to make a screenshot and bans him",STRING_VERSION);
		plugin_registercmd("admin_ss","admin_ss",ACCESS_BAN,"admin_ss: forces player to make a screenshot and bans him");
		plugin_registercmd("admin_ss_list","admin_ss_list",ACCESS_BAN,"admin_ss_list <line>: displays a list from whom screenshots are made, starting at 'line'");
	}
	return PLUGIN_CONTINUE;
}

public admin_ss(HLCommand,HLData,HLUserName,UserIndex) {
	new Text[MAX_DATA_LENGTH];
	new Player[MAX_DATA_LENGTH];
	new Target[MAX_NAME_LENGTH];
	new User[MAX_NAME_LENGTH];
	new ST[MAX_DATA_LENGTH];
	new AuthID[MAX_AUTHID_LENGTH];
	
	convert_string(HLData,Player,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	
	if (check_user(Player)==1) {
		get_username(Player,Target,MAX_NAME_LENGTH);
		if(check_immunity(Player)==1) {
			snprintf(Text, MAX_TEXT_LENGTH, "Laf. You can't force '%s' to make a screenshot, you silly bear.", Target);
			selfmessage(Text);
			return PLUGIN_HANDLED;
		}
		get_userAuthID(Target,AuthID,MAX_AUTHID_LENGTH);
		
		servertime(ST, MAX_DATA_LENGTH, "%d.%m.%y/%H:%M:%S");
		snprintf(Text,MAX_TEXT_LENGTH,"%s: Please send this screenshot to %s and your ban will be removed!",ST,g_Contact);
		messageex(Target,Text,print_chat);
		snprintf(Text,MAX_TEXT_LENGTH,"%s: Bitte sende diesen Screenshot an %s und Dein Ban wird aufgehoben!",ST,g_Contact);
		messageex(Target,Text,print_chat);
		snprintf(Text,MAX_TEXT_LENGTH,"%s: Please send this screenshot to %s and your ban will be removed!",ST,g_Contact);
		messageex(Target,Text,print_chat);
		snprintf(Text,MAX_TEXT_LENGTH,"%s: Bitte sende diesen Screenshot an %s und Dein Ban wird aufgehoben!",ST,g_Contact);
		messageex(Target,Text,print_chat);
		execclient(Target, "snapshot");
		/*Info will be written to g_ScreenshotCFG, which is set above*/
		snprintf(Text,MAX_TEXT_LENGTH,"%s: Admin: %s - Player: %s(%i)",ST,User,Target,AuthID);
		writefile(g_ScreenshotCFG,Text,-1);
		/*for plugin_sdal_banCS16 :)*/
		snprintf(Text,MAX_TEXT_LENGTH,"%s 0 Screenshot",Target);
		plugin_exec("admin_ban",Text);		
	}else{
		snprintf(Text,MAX_TEXT_LENGTH,"[ADMIN_SS] Unrecognized player: %s",Player);
		selfmessage("");
		selfmessage(Text);
		selfmessage("");
	}
	return PLUGIN_HANDLED;
}

public admin_ss_list(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	read_file(Data);
	return PLUGIN_HANDLED;
}

read_file(Line[]){
	new Text[MAX_TEXT_LENGTH];
	new ReadData[MAX_DATA_LENGTH];
	new i;
	new iLine;
	new filelines;
	
	iLine=strtonum(Line);
	
	snprintf(Text,MAX_TEXT_LENGTH,"[ADMIN_SS] READING FILE: %s",g_ScreenshotCFG);
	selfmessage(Text);
	if(fileexists(g_ScreenshotCFG)){
		filelines=filesize(g_ScreenshotCFG);
		if(iLine > filelines || iLine < 0){
			selfmessage("");
			selfmessage("Line not found!");
			selfmessage("");
			selfmessage("----------------------");
			snprintf(Text,MAX_TEXT_LENGTH,"Total lines: %i",filelines);
			selfmessage(Text);
			return PLUGIN_CONTINUE;
		}
		for(i=iLine;i<iLine+10;i++){
			if(i>filelines){
				i--;
				break;
			}
			readfile(g_ScreenshotCFG,ReadData,i,MAX_TEXT_LENGTH);
			snprintf(Text,MAX_TEXT_LENGTH,"%i. %s",i,ReadData);
			selfmessage(Text);
		}
		selfmessage("");
		selfmessage("----------------------");
		snprintf(Text,MAX_TEXT_LENGTH,"Line: %i to %i",iLine,i);
		selfmessage(Text);
		snprintf(Text,MAX_TEXT_LENGTH,"Total Lines: %i",filelines);
		selfmessage(Text);
	}else{
		selfmessage("");
		snprintf(Text,MAX_TEXT_LENGTH,"File %s not found!",g_ScreenshotCFG);
		selfmessage(Text);
		selfmessage("");
		selfmessage("----------------------");
	}
	return PLUGIN_CONTINUE;
}	